/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@cithraidt.de>               */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 15.06.2007                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


#include <windows.h>
#include <vfw.h>
#include "version.h"

#define CODEC_NAME L"Cedocida DV"
#define CODEC_DESCRIPTION_DVSD L"Cedocida DV Codec v"VERSION_VFW
#define CODEC_DESCRIPTION_DV25 L"Cedocida DVCPRO25 Codec v"VERSION_VFW
#define CODEC_DESCRIPTION_DV50 L"Cedocida DVCPRO50 Codec v"VERSION_VFW

#define SETTINGS_REG_KEY	     HKEY_CURRENT_USER
#define SETTINGS_REG_PARENT	     L"Software\\Cedocida"
#define SETTINGS_REG_NAME_DVSD   SETTINGS_REG_PARENT L"\\dvsd"
#define SETTINGS_REG_NAME_DV25   SETTINGS_REG_PARENT L"\\dv25"
#define SETTINGS_REG_NAME_DV50   SETTINGS_REG_PARENT L"\\dv50"
#define SETTINGS_REG_VAL         L"v" VERSION_VFW

static const DWORD FOURCC_dvsd = mmioFOURCC('d','v','s','d');   // DV standard
static const DWORD FOURCC_dv25 = mmioFOURCC('d','v','2','5');
static const DWORD FOURCC_dv50 = mmioFOURCC('d','v','5','0');

static const DWORD FOURCC_VYUY = mmioFOURCC('V','Y','U','Y');   // an alias for YUY2 used by ATI cards
static const DWORD FOURCC_UYVY = mmioFOURCC('U','Y','V','Y');   // uncompressed UYVY
static const DWORD FOURCC_YUY2 = mmioFOURCC('Y','U','Y','2');   // uncompressed YUY2
static const DWORD FOURCC_YUYV = mmioFOURCC('Y','U','Y','V');   // uncompressed YUYV - same as YUY2
static const DWORD FOURCC_V422 = mmioFOURCC('V','4','2','2');   // uncompressed V422 - same as YUY2
static const DWORD FOURCC_YVYU = mmioFOURCC('Y','V','Y','U');   // uncompressed YVYU
static const DWORD FOURCC_YV12 = mmioFOURCC('Y','V','1','2');   // uncompressed YV12


/****************************************
	standard driver messages
****************************************/

LONG my_drv_configure(void *hnd, LPARAM lParam1);
DWORD_PTR my_drv_open(LPARAM lParam2) ;
LONG my_drv_load();
LONG my_drv_close(void *hnd);


/****************************************
	state messages
****************************************/

LONG my_icm_about(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_configure(void *hnd, LPARAM lParam1);
LONG my_icm_getstate(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_setstate(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_getinfo(void *hnd, LPARAM lParam1, LPARAM lParam2);


/****************************************
	compress messages
****************************************/

LONG my_icm_compress_query(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_compress_get_format(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_get_size(void *hnd, LPARAM lParam1);
LONG my_icm_compress_begin(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_compress(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_compress_end(void *hnd);


/****************************************
	decompress messages
****************************************/

LONG my_icm_decompress_query(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_decompress_get_format(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_decompress_begin(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_decompress(void *hnd, LPARAM lParam1, LPARAM lParam2);
LONG my_icm_decompress_end(void *hnd);


