/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@cithraidt.de>               */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 15.06.2007                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/



extern "C" {

void mmx_ConvertRGB24toYUY2_ad(const uint8_t *src, uint8_t *dst, int src_pitch, int dst_pitch, int w, int h, int rec601);
void mmx_ConvertRGB32toYUY2_ad(const uint8_t *src, uint8_t *dst, int src_pitch, int dst_pitch, int w, int h, int rec601);

void mmx_yv12_to_yuy2(
	const uint8_t* srcY, 
	const uint8_t* srcU, 
	const uint8_t* srcV, 
	int src_rowsize, 
	int src_pitch, 
	int src_pitch_uv, 
	uint8_t* dst, 
	int dst_pitch,
	int height);

void mmx_yv12_i_to_yuy2(
	const uint8_t* srcY, 
	const uint8_t* srcU, 
	const uint8_t* srcV, 
	int src_rowsize, 
	int src_pitch, 
	int src_pitch_uv, 
	uint8_t* dst,
	int dst_pitch,
	int height);

void mmx_yuy2_to_yv12(
	const uint8_t* src, 
	int src_rowsize, 
	int src_pitch, 
	uint8_t* dstY, 
	uint8_t* dstU, 
	uint8_t* dstV, 
	int dst_pitch, 
	int dst_pitchUV,
	int height);

void mmx_yuy2_i_to_yv12(
	const uint8_t* src, 
	int src_rowsize, 
	int src_pitch, 
	uint8_t* dstY, 
	uint8_t* dstU, 
	uint8_t* dstV, 
	int dst_pitch, 
	int dst_pitchUV,
	int height);

// in convert_rgb_mmx.asm
void mmx_YUY2toRGB24(const uint8_t* src, uint8_t* dst, const uint8_t* src_end, int src_pitch, int row_size, int rec709);
void mmx_YUY2toRGB32(const uint8_t* src, uint8_t* dst, const uint8_t* src_end, int src_pitch, int row_size, int rec709);

}



