/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@cithraidt.de>               */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 22.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


// MB_order in SB
const unsigned char SB_row_order[3][9] = { 
	{ 0, 5, 6,11,12,17,18,23,24}, 
	{ 1, 4, 7,10,13,16,19,22,25},
	{ 2, 3, 8, 9,14,15,20,21,26} 
};


// macro-block position relative to super-block
// interleaved x- and y-position
const unsigned char MB_pos_NTSC[5][2*27] = { 
	{ 
	0,0,  0,1,  0,2,  0,3,  0,4,  0,5,  
	1,5,  1,4,  1,3,  1,2,  1,1,  1,0,  
	2,0,  2,1,  2,2,  2,3,  2,4,  2,5,
	3,5,  3,4,  3,3,  3,2,  3,1,  3,0,
	4,0,  4,1,  4,2                   
	},
	{                 4,3,  4,4,  4,5,  
	5,5,  5,4,  5,3,  5,2,  5,1,  5,0,  
	6,0,  6,1,  6,2,  6,3,  6,4,  6,5,
	7,5,  7,4,  7,3,  7,2,  7,1,  7,0,
	8,0,  8,1,  8,2,  8,3,  8,4,  8,5 
	},
	{ 
	 9,0,   9,1,   9,2,   9,3,   9,4,   9,5,  
	10,5,  10,4,  10,3,  10,2,  10,1,  10,0,  
	11,0,  11,1,  11,2,  11,3,  11,4,  11,5,
	12,5,  12,4,  12,3,  12,2,  12,1,  12,0,
	13,0,  13,1,  13,2                   
	},
	{                    13,3,  13,4,  13,5,  
	14,5,  14,4,  14,3,  14,2,  14,1,  14,0,  
	15,0,  15,1,  15,2,  15,3,  15,4,  15,5,
	16,5,  16,4,  16,3,  16,2,  16,1,  16,0,
	17,0,  17,1,  17,2,  17,3,  17,4,  17,5 
	},
	{ 
	18,0,  18,1,  18,2,  18,3,  18,4,  18,5,  
	19,5,  19,4,  19,3,  19,2,  19,1,  19,0,  
	20,0,  20,1,  20,2,  20,3,  20,4,  20,5,
	21,5,  21,4,  21,3,  21,2,  21,1,  21,0,
	22,0,  22,2,  22,4                   
	},
};


//q = quantization_code_table[(c1c0<<4)+QNO], QNO = 0..15, c1c0 = 0..3
const uint32_t quantization_code_table[16*4] = {
	 5,  5,  4,  4,  3,  3,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,
	 7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  0,  0,  0,  0,
	 8,  8,  7,  7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  0,
	 8,  7,  7,  6,  6,  5,  5,  4,  4,  3,  3,  2,  2,  1,  0,  0
};


//q = quantization_code_table[(c1c0<<4)+QNO], QNO = 0..15, c1c0 = 0..3
const uint32_t quantization_code_table_extended[16*4] = {
	 7,  7,  6,  6,  3,  3,  2,  2,  1,  0,  0,  0,  0,  0,  0,  0,
	 9,  8,  8,  7,  7,  6,  6,  3,  3,  2,  2,  1,  0,  0,  0,  0,
	10, 10,  9,  9,  8,  8,  7,  7,  6,  6,  3,  3,  2,  2,  1,  0,
	12, 11, 11, 10, 10,  9,  9,  8,  8,  7,  7,  6,  6,  5,  4,  4
};


