%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

function [run, amp] = get_runamp( code, len, run_table, amp_table, code_table, len_table )

% first some special cases which are not in the "vlc_table.m"
%------------------------------------------------------------
if ( len==13 )
   code_front = floor( code/(2^6) );
   if ( code_front == 126 )	%1111110
      code_back = rem( code, 2^7 );
      if ( (code_back < 6) | (code_back > 61) )	% this is no correct codeword 
         amp = -1;
         run = -1;
      else
         amp = 0;
         run = code_back;
      end
      
      return;
      
   end
end

if ( len==16 )
   code_front = floor( code/(2^9) );
   if ( code_front == 127 )	%1111111
      code_back = rem( code, 2^9 );
	   sign = 1-2*rem( code_back, 2 );
      amp_unsigned = floor( code_back/2 );
      if ( amp_unsigned < 23 )	% this is no correct codeword
         amp = -1;
         run = -1;
      else
      	run = 0;
         amp = sign*amp_unsigned;
      end
      
      return
      
   end
end


% now the rest 
%-------------------------
% try it without the last bit (maybe the sign!)
code_unsigned = floor(code/2);
len_unsigned = len-1;
indx = find( (code_table==code_unsigned) & (len_table==len_unsigned) );
if (~isempty(indx))
   sign = 1-2*rem( code, 2 );
   run = run_table(indx);
   amp = sign*amp_table(indx);
   if (amp==0)
	   run = NaN;
      amp = NaN;
   end
else % ok, try it without the sign (=> amp=0)
	indx = find( (code_table==code) & (len_table==len) );
   if (~isempty(indx))
      run = run_table(indx);
      amp = amp_table(indx);
      if (amp~=0)
	   	run = NaN;
   	   amp = NaN;
	   end
	else
	   run = NaN;
      amp = NaN;
   end
end




