%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

OUTPUT_FILENAME_1 = '_block_scanning_88_unrolled_asm.cpp';
OUTPUT_FILENAME_2 = '_block_scanning_248_unrolled_asm.cpp';
OUTPUT_FILENAME_3 = '_get_vlc_length_88_unrolled_asm.cpp';
OUTPUT_FILENAME_4 = '_get_vlc_length_248_unrolled_asm.cpp';

fid1 = fopen( OUTPUT_FILENAME_1, 'w' );
fid2 = fopen( OUTPUT_FILENAME_2, 'w' );
fid3 = fopen( OUTPUT_FILENAME_3, 'w' );
fid4 = fopen( OUTPUT_FILENAME_4, 'w' );


scan_order_88 = [ ....
      1 2 6 7 15 16 28 29 ...
      3 5 8 14 17 27 30 43 ...
      4 9 13 18 26 31 42 44 ...
      10 12 19 25 32 41 45 54 ...
      11 20 24 33 40 46 53 55 ...
      21 23 34 39 47 52 56 61 ...
      22 35 38 48 51 57 60 62 ...
      36 37 49 50 58 59 63 64 ];
scan_order_88_inv = zeros(1,64);
for i=[1:64]
   scan_order_88_inv( scan_order_88(i) ) = i;
end

scan_order_248 = [ ...
      1 3 7 19 21 35 37 51 ...
      5 9 17 23 33 39 49 53 ...
      11 15 25 31 41 47 55 61 ...
      13 27 29 43 45 57 59 63 ...
      2 4 8 20 22 36 38 52 ...
      6 10 18 24 34 40 50 54 ...
      12 16 26 32 42 48 56 62 ...
      14 28 30 44 46 58 60 64 ...
];
scan_order_248_inv = zeros(1,64);
for i=[1:64]
   scan_order_248_inv( scan_order_248(i) ) = i;
end





fid = fid1;
fprintf(fid,'\n\n');
fprintf(fid, '\txor eax, eax	; run\n');
fprintf(fid, '\tmovsx	esi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(2)-2);
fprintf(fid,'\n');
fprintf(fid, '\ttest esi, esi\n');
fprintf(fid, '\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(3)-2);
fprintf(fid, '\tje c02\n');
fprintf(fid, '\tmov [esp+12],esi\n');
fprintf(fid, '\tmov [esp+8], eax\n');
fprintf(fid, '\tcall put_vlc_code\n');
fprintf(fid, '\tmov eax, -1\n');
fprintf(fid,'\n');
for n=2:62,
   if ( rem(n,2)==0 )
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest edi, edi\n');
	fprintf(fid, '\tmovsx esi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tmov [esp+12],edi\n');
	fprintf(fid, '\tadd eax, %i\n',n-1);
	fprintf(fid, '\tmov [esp+8], eax\n');
	fprintf(fid, '\tcall put_vlc_code\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   else
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest esi, esi\n');
	fprintf(fid, '\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tmov [esp+12],esi\n');
	fprintf(fid, '\tadd eax, %i\n',n-1);
	fprintf(fid, '\tmov [esp+8], eax\n');
	fprintf(fid, '\tcall put_vlc_code\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   end
end
fprintf(fid, '\n');


fid = fid2;
fprintf(fid,'\n\n');
fprintf(fid, '\txor eax, eax	; run\n');
fprintf(fid, '\tmovsx	esi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(2)-2);
fprintf(fid,'\n');
fprintf(fid, '\ttest esi, esi\n');
fprintf(fid, '\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(3)-2);
fprintf(fid, '\tje c02\n');
fprintf(fid, '\tmov [esp+12],esi\n');
fprintf(fid, '\tmov [esp+8], eax\n');
fprintf(fid, '\tcall put_vlc_code\n');
fprintf(fid, '\tmov eax, -1\n');
fprintf(fid,'\n');
for n=2:62,
   if ( rem(n,2)==0 )
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest edi, edi\n');
	fprintf(fid, '\tmovsx esi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tmov [esp+12],edi\n');
	fprintf(fid, '\tadd eax, %i\n',n-1);
	fprintf(fid, '\tmov [esp+8], eax\n');
	fprintf(fid, '\tcall put_vlc_code\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   else
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest esi, esi\n');
	fprintf(fid, '\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tmov [esp+12],esi\n');
	fprintf(fid, '\tadd eax, %i\n',n-1);
	fprintf(fid, '\tmov [esp+8], eax\n');
	fprintf(fid, '\tcall put_vlc_code\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   end
end
fprintf(fid, '\n');



fid = fid3;
fprintf(fid,'\n\n');
fprintf(fid,'\txor ecx, ecx	; sum of length\n');
fprintf(fid,'\n');		
fprintf(fid,'\txor eax, eax	; run\n');
fprintf(fid,'\tmovsx	esi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(2)-2);
fprintf(fid,'\n');		
fprintf(fid,'\ttest esi, esi\n');
fprintf(fid,'\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(3)-2);
fprintf(fid,'\tje c02\n');
fprintf(fid,'\tcall get_vlc_length_eax_esi_eax\n');
fprintf(fid,'\tadd ecx, eax\n');
fprintf(fid,'\tmov eax, -1\n');
fprintf(fid,'\n');
for n=2:62,
   if ( rem(n,2)==0 )
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest edi, edi\n');
	fprintf(fid, '\tmovsx esi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tadd eax, %i\n',n-1);
   fprintf(fid, '\tcall get_vlc_length_eax_edi_eax\n');
   fprintf(fid, '\tadd ecx, eax\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   else
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest esi, esi\n');
	fprintf(fid, '\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_88_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tadd eax, %i\n',n-1);
	fprintf(fid, '\tcall get_vlc_length_eax_esi_eax\n');
   fprintf(fid, '\tadd ecx, eax\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   end
end
fprintf(fid, '\n');


fid = fid4;
fprintf(fid,'\n\n');
fprintf(fid,'\txor ecx, ecx	; sum of length\n');
fprintf(fid,'\n');		
fprintf(fid,'\txor eax, eax	; run\n');
fprintf(fid,'\tmovsx	esi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(2)-2);
fprintf(fid,'\n');		
fprintf(fid,'\ttest esi, esi\n');
fprintf(fid,'\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(3)-2);
fprintf(fid,'\tje c02\n');
fprintf(fid,'\tcall get_vlc_length_eax_esi_eax\n');
fprintf(fid,'\tadd ecx, eax\n');
fprintf(fid,'\tmov eax, -1\n');
fprintf(fid,'\n');
for n=2:62,
   if ( rem(n,2)==0 )
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest edi, edi\n');
	fprintf(fid, '\tmovsx esi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tadd eax, %i\n',n-1);
   fprintf(fid, '\tcall get_vlc_length_eax_edi_eax\n');
   fprintf(fid, '\tadd ecx, eax\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   else
	fprintf(fid, 'c%02i:\n',n);
	fprintf(fid, '\ttest esi, esi\n');
	fprintf(fid, '\tmovsx edi, WORD PTR [ebx+%2i]\n',2*scan_order_248_inv(n+2)-2);
   fprintf(fid, '\tje c%02i\n',n+1);
	fprintf(fid, '\tadd eax, %i\n',n-1);
	fprintf(fid, '\tcall get_vlc_length_eax_esi_eax\n');
   fprintf(fid, '\tadd ecx, eax\n');
   fprintf(fid, '\tmov eax, -%i\n',n);
   end
end
fprintf(fid, '\n');



fclose('all');

