/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@cithraidt.de>               */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/



extern uint32_t (* const get_vlc_length_unrolled[2])(int16_t const *block);


typedef struct {
	uint8_t mode[6];
	uint8_t class_number[6];
	uint8_t quantization_number;
} compressed_macroblock;


typedef struct {
	uint8_t mode[5*6+2];  // +x for proper alignment
	uint8_t quantization_number[5+3]; 
	uint8_t class_number[5*6+2]; 
	int sequence_number;
	int block_number;
	int ch;
	int is_MB211;
} DIF_segment_desc;


int encode_videosegment(
	uint8_t * dst_DIF_block, 
	int16_t const * src_QTMB, 
	DIF_segment_desc const * psegdesc);

uint32_t get_videosegment_length(int16_t const *QTMB, uint32_t const *DCT_mode);
