;*****************************************************************************/
;                                                                            */
;  Cedocida DV-Codec                                                         */
;                                                                            */
;  Copyright (C) 2005 Andreas Dittrich <dittrich@cithraidt.de>               */
;  Project start: 15.12.2003                                                 */
;  Last change  : 15.06.2007                                                 */
;                                                                            */
;*****************************************************************************/
;                                                                            */
;  This program is free software; you can redistribute it and/or modify      */
;  it under the terms of the GNU General Public License as published by      */
;  the Free Software Foundation; either version 2 of the License, or         */
;  (at your option) any later version.                                       */
;                                                                            */
;  This program is distributed in the hope that it will be useful,           */
;  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
;  GNU General Public License for more details.                              */
;                                                                            */
;  You should have received a copy of the GNU General Public License         */
;  along with this program; if not, write to the Free Software               */
;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
;                                                                            */
;*****************************************************************************/

%include "../nasm.inc"


cglobal block_scanning_88_unrolled_asm
cglobal block_scanning_248_unrolled_asm
cglobal get_vlc_length_88_unrolled_asm
cglobal get_vlc_length_248_unrolled_asm

cextern put_vlc_code
cextern putbits
cextern vlc_table1
cextern vlc_table2
cextern vlc_table3
cextern vlc_table4



;=============================================================================
; Code
;=============================================================================

SECTION .text


block_scanning_88_unrolled_asm:
		push ebx
		push ecx
		push esi
		push edi

		mov ebx, DWORD [esp+ 4+(4*4)]	; block
		mov esi, DWORD [esp+ 8+(4*4)]	; blk_bb
		mov edi, DWORD [esp+ 12+(4*4)]	; MB_VLC32b

		sub esp, 8	; placeholder *amp* / *length*,  placeholder *run* / *code*
		push edi	; MB_VLC32b
		push esi	; blk_bb

		xor eax, eax	; run
		movsx	esi, WORD [ebx+2]

		test esi, esi
		movsx edi, WORD [ebx+16]
		je .c02
		mov [esp+12],esi
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -1
	.c02:
		test edi, edi
		movsx esi, WORD [ebx+32]
		je .c03
		mov [esp+12],edi
		add eax, 1
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -2
	.c03:
		test esi, esi
		movsx edi, WORD [ebx+18]
		je .c04
		mov [esp+12],esi
		add eax, 2
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -3
	.c04:
		test edi, edi
		movsx esi, WORD [ebx+ 4]
		je .c05
		mov [esp+12],edi
		add eax, 3
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -4
	.c05:
		test esi, esi
		movsx edi, WORD [ebx+ 6]
		je .c06
		mov [esp+12],esi
		add eax, 4
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -5
	.c06:
		test edi, edi
		movsx esi, WORD [ebx+20]
		je .c07
		mov [esp+12],edi
		add eax, 5
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -6
	.c07:
		test esi, esi
		movsx edi, WORD [ebx+34]
		je .c08
		mov [esp+12],esi
		add eax, 6
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -7
	.c08:
		test edi, edi
		movsx esi, WORD [ebx+48]
		je .c09
		mov [esp+12],edi
		add eax, 7
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -8
	.c09:
		test esi, esi
		movsx edi, WORD [ebx+64]
		je .c10
		mov [esp+12],esi
		add eax, 8
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -9
	.c10:
		test edi, edi
		movsx esi, WORD [ebx+50]
		je .c11
		mov [esp+12],edi
		add eax, 9
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -10
	.c11:
		test esi, esi
		movsx edi, WORD [ebx+36]
		je .c12
		mov [esp+12],esi
		add eax, 10
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -11
	.c12:
		test edi, edi
		movsx esi, WORD [ebx+22]
		je .c13
		mov [esp+12],edi
		add eax, 11
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -12
	.c13:
		test esi, esi
		movsx edi, WORD [ebx+ 8]
		je .c14
		mov [esp+12],esi
		add eax, 12
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -13
	.c14:
		test edi, edi
		movsx esi, WORD [ebx+10]
		je .c15
		mov [esp+12],edi
		add eax, 13
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -14
	.c15:
		test esi, esi
		movsx edi, WORD [ebx+24]
		je .c16
		mov [esp+12],esi
		add eax, 14
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -15
	.c16:
		test edi, edi
		movsx esi, WORD [ebx+38]
		je .c17
		mov [esp+12],edi
		add eax, 15
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -16
	.c17:
		test esi, esi
		movsx edi, WORD [ebx+52]
		je .c18
		mov [esp+12],esi
		add eax, 16
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -17
	.c18:
		test edi, edi
		movsx esi, WORD [ebx+66]
		je .c19
		mov [esp+12],edi
		add eax, 17
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -18
	.c19:
		test esi, esi
		movsx edi, WORD [ebx+80]
		je .c20
		mov [esp+12],esi
		add eax, 18
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -19
	.c20:
		test edi, edi
		movsx esi, WORD [ebx+96]
		je .c21
		mov [esp+12],edi
		add eax, 19
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -20
	.c21:
		test esi, esi
		movsx edi, WORD [ebx+82]
		je .c22
		mov [esp+12],esi
		add eax, 20
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -21
	.c22:
		test edi, edi
		movsx esi, WORD [ebx+68]
		je .c23
		mov [esp+12],edi
		add eax, 21
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -22
	.c23:
		test esi, esi
		movsx edi, WORD [ebx+54]
		je .c24
		mov [esp+12],esi
		add eax, 22
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -23
	.c24:
		test edi, edi
		movsx esi, WORD [ebx+40]
		je .c25
		mov [esp+12],edi
		add eax, 23
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -24
	.c25:
		test esi, esi
		movsx edi, WORD [ebx+26]
		je .c26
		mov [esp+12],esi
		add eax, 24
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -25
	.c26:
		test edi, edi
		movsx esi, WORD [ebx+12]
		je .c27
		mov [esp+12],edi
		add eax, 25
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -26
	.c27:
		test esi, esi
		movsx edi, WORD [ebx+14]
		je .c28
		mov [esp+12],esi
		add eax, 26
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -27
	.c28:
		test edi, edi
		movsx esi, WORD [ebx+28]
		je .c29
		mov [esp+12],edi
		add eax, 27
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -28
	.c29:
		test esi, esi
		movsx edi, WORD [ebx+42]
		je .c30
		mov [esp+12],esi
		add eax, 28
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -29
	.c30:
		test edi, edi
		movsx esi, WORD [ebx+56]
		je .c31
		mov [esp+12],edi
		add eax, 29
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -30
	.c31:
		test esi, esi
		movsx edi, WORD [ebx+70]
		je .c32
		mov [esp+12],esi
		add eax, 30
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -31
	.c32:
		test edi, edi
		movsx esi, WORD [ebx+84]
		je .c33
		mov [esp+12],edi
		add eax, 31
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -32
	.c33:
		test esi, esi
		movsx edi, WORD [ebx+98]
		je .c34
		mov [esp+12],esi
		add eax, 32
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -33
	.c34:
		test edi, edi
		movsx esi, WORD [ebx+112]
		je .c35
		mov [esp+12],edi
		add eax, 33
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -34
	.c35:
		test esi, esi
		movsx edi, WORD [ebx+114]
		je .c36
		mov [esp+12],esi
		add eax, 34
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -35
	.c36:
		test edi, edi
		movsx esi, WORD [ebx+100]
		je .c37
		mov [esp+12],edi
		add eax, 35
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -36
	.c37:
		test esi, esi
		movsx edi, WORD [ebx+86]
		je .c38
		mov [esp+12],esi
		add eax, 36
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -37
	.c38:
		test edi, edi
		movsx esi, WORD [ebx+72]
		je .c39
		mov [esp+12],edi
		add eax, 37
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -38
	.c39:
		test esi, esi
		movsx edi, WORD [ebx+58]
		je .c40
		mov [esp+12],esi
		add eax, 38
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -39
	.c40:
		test edi, edi
		movsx esi, WORD [ebx+44]
		je .c41
		mov [esp+12],edi
		add eax, 39
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -40
	.c41:
		test esi, esi
		movsx edi, WORD [ebx+30]
		je .c42
		mov [esp+12],esi
		add eax, 40
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -41
	.c42:
		test edi, edi
		movsx esi, WORD [ebx+46]
		je .c43
		mov [esp+12],edi
		add eax, 41
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -42
	.c43:
		test esi, esi
		movsx edi, WORD [ebx+60]
		je .c44
		mov [esp+12],esi
		add eax, 42
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -43
	.c44:
		test edi, edi
		movsx esi, WORD [ebx+74]
		je .c45
		mov [esp+12],edi
		add eax, 43
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -44
	.c45:
		test esi, esi
		movsx edi, WORD [ebx+88]
		je .c46
		mov [esp+12],esi
		add eax, 44
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -45
	.c46:
		test edi, edi
		movsx esi, WORD [ebx+102]
		je .c47
		mov [esp+12],edi
		add eax, 45
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -46
	.c47:

		mov edi, DWORD [ebx+76]		;76 & 78
		mov ecx, esi
		mov esi, DWORD [ebx+92]		; 92 & 94
		or ecx, edi
		mov edi, DWORD [ebx+104]	;104 & 106
		or ecx, esi
		mov esi, DWORD [ebx+108]	;108 & 110
		or ecx, edi
		mov edi, DWORD [ebx+116]	;116 & 118
		or ecx, esi
		mov esi, DWORD [ebx+120]	;120 & 122
		or ecx, edi
		mov edi, DWORD [ebx+124]	;124 & 126
		or ecx, esi
		movsx esi, WORD [ebx+62]
		or ecx, edi
		movsx edi, WORD [ebx+90]
		or ecx, esi
		or ecx, edi
		je .c64
		movsx esi, WORD [ebx+102]


		test esi, esi
		movsx edi, WORD [ebx+116]
		je .c48
		mov [esp+12],esi
		add eax, 46
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -47
	.c48:
		test edi, edi
		movsx esi, WORD [ebx+118]
		je .c49
		mov [esp+12],edi
		add eax, 47
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -48
	.c49:
		test esi, esi
		movsx edi, WORD [ebx+104]
		je .c50
		mov [esp+12],esi
		add eax, 48
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -49
	.c50:
		test edi, edi
		movsx esi, WORD [ebx+90]
		je .c51
		mov [esp+12],edi
		add eax, 49
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -50
	.c51:
		test esi, esi
		movsx edi, WORD [ebx+76]
		je .c52
		mov [esp+12],esi
		add eax, 50
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -51
	.c52:
		test edi, edi
		movsx esi, WORD [ebx+62]
		je .c53
		mov [esp+12],edi
		add eax, 51
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -52
	.c53:
		test esi, esi
		movsx edi, WORD [ebx+78]
		je .c54
		mov [esp+12],esi
		add eax, 52
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -53
	.c54:
		test edi, edi
		movsx esi, WORD [ebx+92]
		je .c55
		mov [esp+12],edi
		add eax, 53
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -54
	.c55:
		test esi, esi
		movsx edi, WORD [ebx+106]
		je .c56
		mov [esp+12],esi
		add eax, 54
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -55
	.c56:
		test edi, edi
		movsx esi, WORD [ebx+120]
		je .c57
		mov [esp+12],edi
		add eax, 55
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -56
	.c57:
		test esi, esi
		movsx edi, WORD [ebx+122]
		je .c58
		mov [esp+12],esi
		add eax, 56
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -57
	.c58:
		test edi, edi
		movsx esi, WORD [ebx+108]
		je .c59
		mov [esp+12],edi
		add eax, 57
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -58
	.c59:
		test esi, esi
		movsx edi, WORD [ebx+94]
		je .c60
		mov [esp+12],esi
		add eax, 58
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -59
	.c60:
		test edi, edi
		movsx esi, WORD [ebx+110]
		je .c61
		mov [esp+12],edi
		add eax, 59
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -60
	.c61:
		test esi, esi
		movsx edi, WORD [ebx+124]
		je .c62
		mov [esp+12],esi
		add eax, 60
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -61
	.c62:
		test edi, edi
		movsx esi, WORD [ebx+126]
		je .c63
		mov [esp+12],edi
		add eax, 61
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -62

	.c63:
		test esi, esi
		je .c64
		mov [esp+12],esi
		add eax, 62
		mov [esp+8], eax
		call put_vlc_code
		;jmp block_scanning_end
	.c64:
		mov DWORD [esp+8], 0x06
		mov DWORD [esp+12],0x04
		call putbits
	;block_scanning_end:

		add esp, 16
		pop edi;
		pop esi;
		pop ecx
		pop ebx;
		ret 0


block_scanning_248_unrolled_asm:
		push ebx
		push ecx
		push esi
		push edi

		mov ebx, DWORD [esp+ 4+(4*4)]	; block
		mov esi, DWORD [esp+ 8+(4*4)]	; blk_bb
		mov edi, DWORD [esp+ 12+(4*4)]	; MB_VLC32b

		sub esp, 8	; placeholder *amp* / *length*,  placeholder *run* / *code*
		push edi	; MB_VLC32b
		push esi	; blk_bb

		xor eax, eax	; run
		movsx	esi, WORD [ebx+64]

		test esi, esi
		movsx edi, WORD [ebx+ 2]
		je .c02
		mov [esp+12],esi
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -1

	.c02:
		test edi, edi
		movsx esi, WORD [ebx+66]
		je .c03
		mov [esp+12],edi
		add eax, 1
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -2
	.c03:
		test esi, esi
		movsx edi, WORD [ebx+16]
		je .c04
		mov [esp+12],esi
		add eax, 2
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -3
	.c04:
		test edi, edi
		movsx esi, WORD [ebx+80]
		je .c05
		mov [esp+12],edi
		add eax, 3
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -4
	.c05:
		test esi, esi
		movsx edi, WORD [ebx+ 4]
		je .c06
		mov [esp+12],esi
		add eax, 4
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -5
	.c06:
		test edi, edi
		movsx esi, WORD [ebx+68]
		je .c07
		mov [esp+12],edi
		add eax, 5
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -6
	.c07:
		test esi, esi
		movsx edi, WORD [ebx+18]
		je .c08
		mov [esp+12],esi
		add eax, 6
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -7
	.c08:
		test edi, edi
		movsx esi, WORD [ebx+82]
		je .c09
		mov [esp+12],edi
		add eax, 7
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -8
	.c09:
		test esi, esi
		movsx edi, WORD [ebx+32]
		je .c10
		mov [esp+12],esi
		add eax, 8
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -9
	.c10:
		test edi, edi
		movsx esi, WORD [ebx+96]
		je .c11
		mov [esp+12],edi
		add eax, 9
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -10
	.c11:
		test esi, esi
		movsx edi, WORD [ebx+48]
		je .c12
		mov [esp+12],esi
		add eax, 10
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -11
	.c12:
		test edi, edi
		movsx esi, WORD [ebx+112]
		je .c13
		mov [esp+12],edi
		add eax, 11
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -12
	.c13:
		test esi, esi
		movsx edi, WORD [ebx+34]
		je .c14
		mov [esp+12],esi
		add eax, 12
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -13
	.c14:
		test edi, edi
		movsx esi, WORD [ebx+98]
		je .c15
		mov [esp+12],edi
		add eax, 13
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -14
	.c15:
		test esi, esi
		movsx edi, WORD [ebx+20]
		je .c16
		mov [esp+12],esi
		add eax, 14
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -15
	.c16:
		test edi, edi
		movsx esi, WORD [ebx+84]
		je .c17
		mov [esp+12],edi
		add eax, 15
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -16
	.c17:
		test esi, esi
		movsx edi, WORD [ebx+ 6]
		je .c18
		mov [esp+12],esi
		add eax, 16
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -17
	.c18:
		test edi, edi
		movsx esi, WORD [ebx+70]
		je .c19
		mov [esp+12],edi
		add eax, 17
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -18
	.c19:
		test esi, esi
		movsx edi, WORD [ebx+ 8]
		je .c20
		mov [esp+12],esi
		add eax, 18
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -19
	.c20:
		test edi, edi
		movsx esi, WORD [ebx+72]
		je .c21
		mov [esp+12],edi
		add eax, 19
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -20
	.c21:
		test esi, esi
		movsx edi, WORD [ebx+22]
		je .c22
		mov [esp+12],esi
		add eax, 20
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -21
	.c22:
		test edi, edi
		movsx esi, WORD [ebx+86]
		je .c23
		mov [esp+12],edi
		add eax, 21
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -22
	.c23:
		test esi, esi
		movsx edi, WORD [ebx+36]
		je .c24
		mov [esp+12],esi
		add eax, 22
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -23
	.c24:
		test edi, edi
		movsx esi, WORD [ebx+100]
		je .c25
		mov [esp+12],edi
		add eax, 23
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -24
	.c25:
		test esi, esi
		movsx edi, WORD [ebx+50]
		je .c26
		mov [esp+12],esi
		add eax, 24
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -25
	.c26:
		test edi, edi
		movsx esi, WORD [ebx+114]
		je .c27
		mov [esp+12],edi
		add eax, 25
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -26
	.c27:
		test esi, esi
		movsx edi, WORD [ebx+52]
		je .c28
		mov [esp+12],esi
		add eax, 26
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -27
	.c28:
		test edi, edi
		movsx esi, WORD [ebx+116]
		je .c29
		mov [esp+12],edi
		add eax, 27
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -28
	.c29:
		test esi, esi
		movsx edi, WORD [ebx+38]
		je .c30
		mov [esp+12],esi
		add eax, 28
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -29
	.c30:
		test edi, edi
		movsx esi, WORD [ebx+102]
		je .c31
		mov [esp+12],edi
		add eax, 29
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -30
	.c31:
		test esi, esi
		movsx edi, WORD [ebx+24]
		je .c32
		mov [esp+12],esi
		add eax, 30
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -31
	.c32:
		test edi, edi
		movsx esi, WORD [ebx+88]
		je .c33
		mov [esp+12],edi
		add eax, 31
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -32
	.c33:
		test esi, esi
		movsx edi, WORD [ebx+10]
		je .c34
		mov [esp+12],esi
		add eax, 32
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -33
	.c34:
		test edi, edi
		movsx esi, WORD [ebx+74]
		je .c35
		mov [esp+12],edi
		add eax, 33
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -34
	.c35:
		test esi, esi
		movsx edi, WORD [ebx+12]
		je .c36
		mov [esp+12],esi
		add eax, 34
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -35
	.c36:
		test edi, edi
		movsx esi, WORD [ebx+76]
		je .c37
		mov [esp+12],edi
		add eax, 35
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -36
	.c37:
		test esi, esi
		movsx edi, WORD [ebx+26]
		je .c38
		mov [esp+12],esi
		add eax, 36
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -37
	.c38:
		test edi, edi
		movsx esi, WORD [ebx+90]
		je .c39
		mov [esp+12],edi
		add eax, 37
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -38
	.c39:
		test esi, esi
		movsx edi, WORD [ebx+40]
		je .c40
		mov [esp+12],esi
		add eax, 38
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -39
	.c40:
		test edi, edi
		movsx esi, WORD [ebx+104]
		je .c41
		mov [esp+12],edi
		add eax, 39
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -40
	.c41:
		test esi, esi
		movsx edi, WORD [ebx+54]
		je .c42
		mov [esp+12],esi
		add eax, 40
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -41
	.c42:
		test edi, edi
		movsx esi, WORD [ebx+118]
		je .c43
		mov [esp+12],edi
		add eax, 41
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -42
	.c43:
		test esi, esi
		movsx edi, WORD [ebx+56]
		je .c44
		mov [esp+12],esi
		add eax, 42
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -43
	.c44:
		test edi, edi
		movsx esi, WORD [ebx+120]
		je .c45
		mov [esp+12],edi
		add eax, 43
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -44
	.c45:
		test esi, esi
		movsx edi, WORD [ebx+42]
		je .c46
		mov [esp+12],esi
		add eax, 44
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -45
	.c46:
		test edi, edi
		movsx esi, WORD [ebx+106]
		je .c47
		mov [esp+12],edi
		add eax, 45
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -46
	.c47:
		test esi, esi
		movsx edi, WORD [ebx+28]
		je .c48
		mov [esp+12],esi
		add eax, 46
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -47
	.c48:
		test edi, edi
		movsx esi, WORD [ebx+92]
		je .c49
		mov [esp+12],edi
		add eax, 47
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -48
	.c49:
		test esi, esi
		movsx edi, WORD [ebx+14]
		je .c50
		mov [esp+12],esi
		add eax, 48
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -49
	.c50:
		test edi, edi
		movsx esi, WORD [ebx+78]
		je .c51
		mov [esp+12],edi
		add eax, 49
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -50
	.c51:
		test esi, esi
		movsx edi, WORD [ebx+30]
		je .c52
		mov [esp+12],esi
		add eax, 50
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -51
	.c52:
		test edi, edi
		movsx esi, WORD [ebx+94]
		je .c53
		mov [esp+12],edi
		add eax, 51
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -52
	.c53:
		test esi, esi
		movsx edi, WORD [ebx+44]
		je .c54
		mov [esp+12],esi
		add eax, 52
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -53
	.c54:
		test edi, edi
		movsx esi, WORD [ebx+108]
		je .c55
		mov [esp+12],edi
		add eax, 53
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -54
	.c55:
		test esi, esi
		movsx edi, WORD [ebx+58]
		je .c56
		mov [esp+12],esi
		add eax, 54
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -55
	.c56:
		test edi, edi
		movsx esi, WORD [ebx+122]
		je .c57
		mov [esp+12],edi
		add eax, 55
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -56
	.c57:
		test esi, esi
		movsx edi, WORD [ebx+60]
		je .c58
		mov [esp+12],esi
		add eax, 56
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -57
	.c58:
		test edi, edi
		movsx esi, WORD [ebx+124]
		je .c59
		mov [esp+12],edi
		add eax, 57
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -58
	.c59:
		test esi, esi
		movsx edi, WORD [ebx+46]
		je .c60
		mov [esp+12],esi
		add eax, 58
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -59
	.c60:
		test edi, edi
		movsx esi, WORD [ebx+110]
		je .c61
		mov [esp+12],edi
		add eax, 59
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -60
	.c61:
		test esi, esi
		movsx edi, WORD [ebx+62]
		je .c62
		mov [esp+12],esi
		add eax, 60
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -61
	.c62:
		test edi, edi
		movsx esi, WORD [ebx+126]
		je .c63
		mov [esp+12],edi
		add eax, 61
		mov [esp+8], eax
		call put_vlc_code
		mov eax, -62

	.c63:
		test esi, esi
		je .c64
		mov [esp+12],esi
		add eax, 62
		mov [esp+8], eax
		call put_vlc_code
		;jmp block_scanning_end
	.c64:
		mov DWORD [esp+8], 0x06
		mov DWORD [esp+12],0x04
		call putbits
	;block_scanning_end:

		add esp, 16
		pop edi;
		pop esi;
		pop ecx
		pop ebx;
		ret 0


get_vlc_length_asm:	
		push ebx
		push ecx

		mov ecx, DWORD [esp+ 4+(4*2)]	; run
		mov ebx, DWORD [esp+ 8+(4*2)]	; amp

		test ebx, ebx
		jns .is_positive
	;is_negative:
		neg ebx
	.is_positive:
		test ecx, ecx
		jne .run_is_not_zero
	;run_is_zero:
		movzx eax, WORD [ebx*4+(vlc_table2+2)]
		pop ecx
		pop ebx
		ret

	.run_is_not_zero:
		sub ecx, 4
		jg .run_is_greater_than_4

		sub ebx, 17
		jg .amp_is_greater_than_17

		imul ecx, (17*8)
		mov eax, DWORD [ecx+ebx*8+(16*8)+(17*8*3)+(vlc_table3+4)]
		pop ecx
		pop ebx
		ret

	.run_is_greater_than_4:
		sub ecx, (14-4)
		jg .run_is_greater_than_14

		sub ebx, 3
		jg .amp_is_greater_than_3_run_is_greater_than_4

		imul ecx, (3*8)
		mov eax, DWORD [ecx+(3*8*9)+ebx*8+(2*8)+vlc_table4+4]
		pop ecx
		pop ebx
		ret

	.run_is_greater_than_14:
		movzx eax, WORD [ecx*4+(14-1)*4+vlc_table1+2]
		movzx ecx, WORD [ebx*4+vlc_table2+2]
		add eax, ecx
		pop ecx
		pop ebx
		ret

	.amp_is_greater_than_17:
		movzx eax, WORD [ecx*4+(4-1)*4+(-1+1)*4+vlc_table1+2]
		movzx ecx, WORD [ebx*4+(17)*4+vlc_table2+2]
		add eax, ecx
		pop ecx
		pop ebx
		ret

	.amp_is_greater_than_3_run_is_greater_than_4:
		movzx eax, WORD [ecx*4+9*4+(4-1+1)*4+vlc_table1+2]
		movzx ecx, WORD [ebx*4+(3)*4+vlc_table2+2]
		add eax, ecx
		pop ecx
		pop ebx
		ret


get_vlc_length_88_unrolled_asm:
		push ebx
		push ecx
		push edx
		push esi
		push edi

		mov ebx, DWORD [esp+ 4+(4*5)]	; block
		xor ecx, ecx	; sum of length

		xor eax, eax	; run
		movsx	esi, WORD [ebx+2]

		test esi, esi
		movsx edi, WORD [ebx+16]
		je .c02
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -1

	.c02:
		test edi, edi
		movsx esi, WORD [ebx+32]
		je .c03
		add eax, 1
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -2
	.c03:
		test esi, esi
		movsx edi, WORD [ebx+18]
		je .c04
		add eax, 2
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -3
	.c04:
		test edi, edi
		movsx esi, WORD [ebx+ 4]
		je .c05
		add eax, 3
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -4
	.c05:
		test esi, esi
		movsx edi, WORD [ebx+ 6]
		je .c06
		add eax, 4
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -5
	.c06:
		test edi, edi
		movsx esi, WORD [ebx+20]
		je .c07
		add eax, 5
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -6
	.c07:
		test esi, esi
		movsx edi, WORD [ebx+34]
		je .c08
		add eax, 6
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -7
	.c08:
		test edi, edi
		movsx esi, WORD [ebx+48]
		je .c09
		add eax, 7
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -8
	.c09:
		test esi, esi
		movsx edi, WORD [ebx+64]
		je .c10
		add eax, 8
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -9
	.c10:
		test edi, edi
		movsx esi, WORD [ebx+50]
		je .c11
		add eax, 9
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -10
	.c11:
		test esi, esi
		movsx edi, WORD [ebx+36]
		je .c12
		add eax, 10
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -11
	.c12:
		test edi, edi
		movsx esi, WORD [ebx+22]
		je .c13
		add eax, 11
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -12
	.c13:
		test esi, esi
		movsx edi, WORD [ebx+ 8]
		je .c14
		add eax, 12
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -13
	.c14:
		test edi, edi
		movsx esi, WORD [ebx+10]
		je .c15
		add eax, 13
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -14
	.c15:
		test esi, esi
		movsx edi, WORD [ebx+24]
		je .c16
		add eax, 14
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -15
	.c16:
		test edi, edi
		movsx esi, WORD [ebx+38]
		je .c17
		add eax, 15
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -16
	.c17:
		test esi, esi
		movsx edi, WORD [ebx+52]
		je .c18
		add eax, 16
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -17
	.c18:
		test edi, edi
		movsx esi, WORD [ebx+66]
		je .c19
		add eax, 17
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -18
	.c19:
		test esi, esi
		movsx edi, WORD [ebx+80]
		je .c20
		add eax, 18
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -19
	.c20:
		test edi, edi
		movsx esi, WORD [ebx+96]
		je .c21
		add eax, 19
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -20
	.c21:
		test esi, esi
		movsx edi, WORD [ebx+82]
		je .c22
		add eax, 20
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -21
	.c22:
		test edi, edi
		movsx esi, WORD [ebx+68]
		je .c23
		add eax, 21
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -22
	.c23:
		test esi, esi
		movsx edi, WORD [ebx+54]
		je .c24
		add eax, 22
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -23
	.c24:
		test edi, edi
		movsx esi, WORD [ebx+40]
		je .c25
		add eax, 23
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -24
	.c25:
		test esi, esi
		movsx edi, WORD [ebx+26]
		je .c26
		add eax, 24
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -25
	.c26:
		test edi, edi
		movsx esi, WORD [ebx+12]
		je .c27
		add eax, 25
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -26
	.c27:
		test esi, esi
		movsx edi, WORD [ebx+14]
		je .c28
		add eax, 26
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -27
	.c28:
		test edi, edi
		movsx esi, WORD [ebx+28]
		je .c29
		add eax, 27
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -28
	.c29:
		test esi, esi
		movsx edi, WORD [ebx+42]
		je .c30
		add eax, 28
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -29
	.c30:
		test edi, edi
		movsx esi, WORD [ebx+56]
		je .c31
		add eax, 29
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -30
	.c31:
		test esi, esi
		movsx edi, WORD [ebx+70]
		je .c32
		add eax, 30
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -31
	.c32:
		test edi, edi
		movsx esi, WORD [ebx+84]
		je .c33
		add eax, 31
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -32
	.c33:
		test esi, esi
		movsx edi, WORD [ebx+98]
		je .c34
		add eax, 32
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -33
	.c34:
		test edi, edi
		movsx esi, WORD [ebx+112]
		je .c35
		add eax, 33
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -34
	.c35:
		test esi, esi
		movsx edi, WORD [ebx+114]
		je .c36
		add eax, 34
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -35
	.c36:
		test edi, edi
		movsx esi, WORD [ebx+100]
		je .c37
		add eax, 35
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -36
	.c37:
		test esi, esi
		movsx edi, WORD [ebx+86]
		je .c38
		add eax, 36
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -37
	.c38:
		test edi, edi
		movsx esi, WORD [ebx+72]
		je .c39
		add eax, 37
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -38
	.c39:
		test esi, esi
		movsx edi, WORD [ebx+58]
		je .c40
		add eax, 38
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -39
	.c40:
		test edi, edi
		movsx esi, WORD [ebx+44]
		je .c41
		add eax, 39
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -40
	.c41:
		test esi, esi
		movsx edi, WORD [ebx+30]
		je .c42
		add eax, 40
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -41
	.c42:
		test edi, edi
		movsx esi, WORD [ebx+46]
		je .c43
		add eax, 41
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -42
	.c43:
		test esi, esi
		movsx edi, WORD [ebx+60]
		je .c44
		add eax, 42
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -43
	.c44:
		test edi, edi
		movsx esi, WORD [ebx+74]
		je .c45
		add eax, 43
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -44
	.c45:
		test esi, esi
		movsx edi, WORD [ebx+88]
		je .c46
		add eax, 44
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -45
	.c46:
		test edi, edi
		movsx esi, WORD [ebx+102]
		je .c47
		add eax, 45
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -46
	.c47:


		mov edi, DWORD [ebx+76]		;76 & 78
		mov edx, esi
		mov esi, DWORD [ebx+92]		; 92 & 94
		or edx, edi
		mov edi, DWORD [ebx+104]	;104 & 106
		or edx, esi
		mov esi, DWORD [ebx+108]	;108 & 110
		or edx, edi
		mov edi, DWORD [ebx+116]	;116 & 118
		or edx, esi
		mov esi, DWORD [ebx+120]	;120 & 122
		or edx, edi
		mov edi, DWORD [ebx+124]	;124 & 126
		or edx, esi
		movzx esi, WORD [ebx+62]
		or edx, edi
		movzx edi, WORD [ebx+90]
		or edx, esi
		or edx, edi
		je .c64
		movsx esi, WORD [ebx+102]
			
			
		test esi, esi
		movsx edi, WORD [ebx+116]
		je .c48
		add eax, 46
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -47
	.c48:
		test edi, edi
		movsx esi, WORD [ebx+118]
		je .c49
		add eax, 47
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -48
	.c49:
		test esi, esi
		movsx edi, WORD [ebx+104]
		je .c50
		add eax, 48
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -49
	.c50:
		test edi, edi
		movsx esi, WORD [ebx+90]
		je .c51
		add eax, 49
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -50
	.c51:
		test esi, esi
		movsx edi, WORD [ebx+76]
		je .c52
		add eax, 50
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -51
	.c52:
		test edi, edi
		movsx esi, WORD [ebx+62]
		je .c53
		add eax, 51
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -52
	.c53:
		test esi, esi
		movsx edi, WORD [ebx+78]
		je .c54
		add eax, 52
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -53
	.c54:
		test edi, edi
		movsx esi, WORD [ebx+92]
		je .c55
		add eax, 53
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -54
	.c55:
		test esi, esi
		movsx edi, WORD [ebx+106]
		je .c56
		add eax, 54
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -55
	.c56:
		test edi, edi
		movsx esi, WORD [ebx+120]
		je .c57
		add eax, 55
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -56
	.c57:
		test esi, esi
		movsx edi, WORD [ebx+122]
		je .c58
		add eax, 56
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -57
	.c58:
		test edi, edi
		movsx esi, WORD [ebx+108]
		je .c59
		add eax, 57
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -58
	.c59:
		test esi, esi
		movsx edi, WORD [ebx+94]
		je .c60
		add eax, 58
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -59
	.c60:
		test edi, edi
		movsx esi, WORD [ebx+110]
		je .c61
		add eax, 59
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -60
	.c61:
		test esi, esi
		movsx edi, WORD [ebx+124]
		je .c62
		add eax, 60
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -61
	.c62:
		test edi, edi
		movsx esi, WORD [ebx+126]
		je .c63
		add eax, 61
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -62
	.c63:
		test esi, esi
		je .c64
		mov [esp+12],esi
		add eax, 62
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		;jmp block_scanning_end
	.c64:
		add ecx, 4
	;block_scanning_end:

		mov eax, ecx

		pop edi;
		pop esi;
		pop edx
		pop ecx
		pop ebx;
		ret 0

	.get_vlc_length_eax_esi_eax:
		test esi, esi
		jns .is_positive
	;is_negative:
		neg esi
	.is_positive:
		test eax, eax
		jne .run_is_not_zero
	;run_is_zero:
		movzx eax, WORD [esi*4+(vlc_table2+2)]
		ret
	.run_is_not_zero:
		sub eax, 4
		jg .run_is_greater_than_4
		sub esi, 17
		jg .amp_is_greater_than_17
		imul eax, (17*8)
		mov eax, DWORD [eax+esi*8+(16*8)+(17*8*3)+(vlc_table3+4)]
		ret
	.run_is_greater_than_4:
		sub eax, (14-4)
		jg .run_is_greater_than_14
		sub esi, 3
		jg .amp_is_greater_than_3_run_is_greater_than_4
		imul eax, (3*8)
		mov eax, DWORD [eax+(3*8*9)+esi*8+(2*8)+vlc_table4+4]
		ret
	.run_is_greater_than_14:
		movzx eax, WORD [eax*4+(14-1)*4+vlc_table1+2]
		movzx edx, WORD [esi*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_17:
		movzx eax, WORD [eax*4+(4-1)*4+(-1+1)*4+vlc_table1+2]
		movzx edx, WORD [esi*4+(17)*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_3_run_is_greater_than_4:
		movzx eax, WORD [eax*4+9*4+(4-1+1)*4+vlc_table1+2]
		movzx edx, WORD [esi*4+(3)*4+vlc_table2+2]
		add eax, edx
		ret

	.get_vlc_length_eax_edi_eax:
		test edi, edi
		jns .is_positive_edi
	;is_negative:
		neg edi
	.is_positive_edi:
		test eax, eax
		jne .run_is_not_zero_edi
	;run_is_zero:
		movzx eax, WORD [edi*4+(vlc_table2+2)]
		ret
	.run_is_not_zero_edi:
		sub eax, 4
		jg .run_is_greater_than_4_edi
		sub edi, 17
		jg .amp_is_greater_than_17_edi
		imul eax, (17*8)
		mov eax, DWORD [eax+edi*8+(16*8)+(17*8*3)+(vlc_table3+4)]
		ret
	.run_is_greater_than_4_edi:
		sub eax, (14-4)
		jg .run_is_greater_than_14_edi
		sub edi, 3
		jg .amp_is_greater_than_3_run_is_greater_than_4_edi
		imul eax, (3*8)
		mov eax, DWORD [eax+(3*8*9)+edi*8+(2*8)+vlc_table4+4]
		ret
	.run_is_greater_than_14_edi:
		movzx eax, WORD [eax*4+(14-1)*4+vlc_table1+2]
		movzx edx, WORD [edi*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_17_edi:
		movzx eax, WORD [eax*4+(4-1)*4+(-1+1)*4+vlc_table1+2]
		movzx edx, WORD [edi*4+(17)*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_3_run_is_greater_than_4_edi:
		movzx eax, WORD [eax*4+9*4+(4-1+1)*4+vlc_table1+2]
		movzx edx, WORD [edi*4+(3)*4+vlc_table2+2]
		add eax, edx
		ret


get_vlc_length_248_unrolled_asm:
		push ebx
		push ecx
		push edx
		push esi
		push edi

		mov ebx, DWORD [esp+ 4+(4*5)]	; block
		xor ecx, ecx	; sum of length

		xor eax, eax	; run
		movsx	esi, WORD [ebx+64]

		test esi, esi
		movsx edi, WORD [ebx+ 2]
		je .c02
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -1

	.c02:
		test edi, edi
		movsx esi, WORD [ebx+66]
		je .c03
		add eax, 1
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -2
	.c03:
		test esi, esi
		movsx edi, WORD [ebx+16]
		je .c04
		add eax, 2
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -3
	.c04:
		test edi, edi
		movsx esi, WORD [ebx+80]
		je .c05
		add eax, 3
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -4
	.c05:
		test esi, esi
		movsx edi, WORD [ebx+ 4]
		je .c06
		add eax, 4
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -5
	.c06:
		test edi, edi
		movsx esi, WORD [ebx+68]
		je .c07
		add eax, 5
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -6
	.c07:
		test esi, esi
		movsx edi, WORD [ebx+18]
		je .c08
		add eax, 6
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -7
	.c08:
		test edi, edi
		movsx esi, WORD [ebx+82]
		je .c09
		add eax, 7
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -8
	.c09:
		test esi, esi
		movsx edi, WORD [ebx+32]
		je .c10
		add eax, 8
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -9
	.c10:
		test edi, edi
		movsx esi, WORD [ebx+96]
		je .c11
		add eax, 9
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -10
	.c11:
		test esi, esi
		movsx edi, WORD [ebx+48]
		je .c12
		add eax, 10
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -11
	.c12:
		test edi, edi
		movsx esi, WORD [ebx+112]
		je .c13
		add eax, 11
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -12
	.c13:
		test esi, esi
		movsx edi, WORD [ebx+34]
		je .c14
		add eax, 12
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -13
	.c14:
		test edi, edi
		movsx esi, WORD [ebx+98]
		je .c15
		add eax, 13
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -14
	.c15:
		test esi, esi
		movsx edi, WORD [ebx+20]
		je .c16
		add eax, 14
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -15
	.c16:
		test edi, edi
		movsx esi, WORD [ebx+84]
		je .c17
		add eax, 15
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -16
	.c17:
		test esi, esi
		movsx edi, WORD [ebx+ 6]
		je .c18
		add eax, 16
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -17
	.c18:
		test edi, edi
		movsx esi, WORD [ebx+70]
		je .c19
		add eax, 17
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -18
	.c19:
		test esi, esi
		movsx edi, WORD [ebx+ 8]
		je .c20
		add eax, 18
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -19
	.c20:
		test edi, edi
		movsx esi, WORD [ebx+72]
		je .c21
		add eax, 19
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -20
	.c21:
		test esi, esi
		movsx edi, WORD [ebx+22]
		je .c22
		add eax, 20
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -21
	.c22:
		test edi, edi
		movsx esi, WORD [ebx+86]
		je .c23
		add eax, 21
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -22
	.c23:
		test esi, esi
		movsx edi, WORD [ebx+36]
		je .c24
		add eax, 22
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -23
	.c24:
		test edi, edi
		movsx esi, WORD [ebx+100]
		je .c25
		add eax, 23
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -24
	.c25:
		test esi, esi
		movsx edi, WORD [ebx+50]
		je .c26
		add eax, 24
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -25
	.c26:
		test edi, edi
		movsx esi, WORD [ebx+114]
		je .c27
		add eax, 25
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -26
	.c27:
		test esi, esi
		movsx edi, WORD [ebx+52]
		je .c28
		add eax, 26
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -27
	.c28:
		test edi, edi
		movsx esi, WORD [ebx+116]
		je .c29
		add eax, 27
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -28
	.c29:
		test esi, esi
		movsx edi, WORD [ebx+38]
		je .c30
		add eax, 28
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -29
	.c30:
		test edi, edi
		movsx esi, WORD [ebx+102]
		je .c31
		add eax, 29
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -30
	.c31:
		test esi, esi
		movsx edi, WORD [ebx+24]
		je .c32
		add eax, 30
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -31
	.c32:
		test edi, edi
		movsx esi, WORD [ebx+88]
		je .c33
		add eax, 31
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -32
	.c33:
		test esi, esi
		movsx edi, WORD [ebx+10]
		je .c34
		add eax, 32
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -33
	.c34:
		test edi, edi
		movsx esi, WORD [ebx+74]
		je .c35
		add eax, 33
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -34
	.c35:
		test esi, esi
		movsx edi, WORD [ebx+12]
		je .c36
		add eax, 34
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -35
	.c36:
		test edi, edi
		movsx esi, WORD [ebx+76]
		je .c37
		add eax, 35
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -36
	.c37:
		test esi, esi
		movsx edi, WORD [ebx+26]
		je .c38
		add eax, 36
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -37
	.c38:
		test edi, edi
		movsx esi, WORD [ebx+90]
		je .c39
		add eax, 37
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -38
	.c39:
		test esi, esi
		movsx edi, WORD [ebx+40]
		je .c40
		add eax, 38
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -39
	.c40:
		test edi, edi
		movsx esi, WORD [ebx+104]
		je .c41
		add eax, 39
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -40
	.c41:
		test esi, esi
		movsx edi, WORD [ebx+54]
		je .c42
		add eax, 40
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -41
	.c42:
		test edi, edi
		movsx esi, WORD [ebx+118]
		je .c43
		add eax, 41
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -42
	.c43:
		test esi, esi
		movsx edi, WORD [ebx+56]
		je .c44
		add eax, 42
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -43
	.c44:
		test edi, edi
		movsx esi, WORD [ebx+120]
		je .c45
		add eax, 43
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -44
	.c45:
		test esi, esi
		movsx edi, WORD [ebx+42]
		je .c46
		add eax, 44
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -45
	.c46:
		test edi, edi
		movsx esi, WORD [ebx+106]
		je .c47
		add eax, 45
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -46
	.c47:
		test esi, esi
		movsx edi, WORD [ebx+28]
		je .c48
		add eax, 46
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -47
	.c48:
		test edi, edi
		movsx esi, WORD [ebx+92]
		je .c49
		add eax, 47
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -48
	.c49:
		test esi, esi
		movsx edi, WORD [ebx+14]
		je .c50
		add eax, 48
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -49
	.c50:
		test edi, edi
		movsx esi, WORD [ebx+78]
		je .c51
		add eax, 49
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -50
	.c51:
		test esi, esi
		movsx edi, WORD [ebx+30]
		je .c52
		add eax, 50
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -51
	.c52:
		test edi, edi
		movsx esi, WORD [ebx+94]
		je .c53
		add eax, 51
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -52
	.c53:
		test esi, esi
		movsx edi, WORD [ebx+44]
		je .c54
		add eax, 52
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -53
	.c54:
		test edi, edi
		movsx esi, WORD [ebx+108]
		je .c55
		add eax, 53
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -54
	.c55:
		test esi, esi
		movsx edi, WORD [ebx+58]
		je .c56
		add eax, 54
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -55
	.c56:
		test edi, edi
		movsx esi, WORD [ebx+122]
		je .c57
		add eax, 55
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -56
	.c57:
		test esi, esi
		movsx edi, WORD [ebx+60]
		je .c58
		add eax, 56
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -57
	.c58:
		test edi, edi
		movsx esi, WORD [ebx+124]
		je .c59
		add eax, 57
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -58
	.c59:
		test esi, esi
		movsx edi, WORD [ebx+46]
		je .c60
		add eax, 58
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -59
	.c60:
		test edi, edi
		movsx esi, WORD [ebx+110]
		je .c61
		add eax, 59
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -60
	.c61:
		test esi, esi
		movsx edi, WORD [ebx+62]
		je .c62
		add eax, 60
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		mov eax, -61
	.c62:
		test edi, edi
		movsx esi, WORD [ebx+126]
		je .c63
		add eax, 61
		call .get_vlc_length_eax_edi_eax
		add ecx, eax
		mov eax, -62

	.c63:
		test esi, esi
		je .c64
		mov [esp+12],esi
		add eax, 62
		call .get_vlc_length_eax_esi_eax
		add ecx, eax
		;jmp block_scanning_end
	.c64:
		add ecx, 4
	;block_scanning_end:

		mov eax, ecx

		pop edi;
		pop esi;
		pop edx
		pop ecx
		pop ebx;
		ret 0

	.get_vlc_length_eax_esi_eax:
		test esi, esi
		jns .is_positive
	;is_negative:
		neg esi
	.is_positive:
		test eax, eax
		jne .run_is_not_zero
	;run_is_zero:
		movzx eax, WORD [esi*4+(vlc_table2+2)]
		ret
	.run_is_not_zero:
		sub eax, 4
		jg .run_is_greater_than_4
		sub esi, 17
		jg .amp_is_greater_than_17
		imul eax, (17*8)
		mov eax, DWORD [eax+esi*8+(16*8)+(17*8*3)+(vlc_table3+4)]
		ret
	.run_is_greater_than_4:
		sub eax, (14-4)
		jg .run_is_greater_than_14
		sub esi, 3
		jg .amp_is_greater_than_3_run_is_greater_than_4
		imul eax, (3*8)
		mov eax, DWORD [eax+(3*8*9)+esi*8+(2*8)+vlc_table4+4]
		ret
	.run_is_greater_than_14:
		movzx eax, WORD [eax*4+(14-1)*4+vlc_table1+2]
		movzx edx, WORD [esi*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_17:
		movzx eax, WORD [eax*4+(4-1)*4+(-1+1)*4+vlc_table1+2]
		movzx edx, WORD [esi*4+(17)*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_3_run_is_greater_than_4:
		movzx eax, WORD [eax*4+9*4+(4-1+1)*4+vlc_table1+2]
		movzx edx, WORD [esi*4+(3)*4+vlc_table2+2]
		add eax, edx
		ret

	.get_vlc_length_eax_edi_eax:
		test edi, edi
		jns .is_positive_edi
	;is_negative:
		neg edi
	.is_positive_edi:
		test eax, eax
		jne .run_is_not_zero_edi
	;run_is_zero:
		movzx eax, WORD [edi*4+(vlc_table2+2)]
		ret
	.run_is_not_zero_edi:
		sub eax, 4
		jg .run_is_greater_than_4_edi
		sub edi, 17
		jg .amp_is_greater_than_17_edi
		imul eax, (17*8)
		mov eax, DWORD [eax+edi*8+(16*8)+(17*8*3)+(vlc_table3+4)]
		ret
	.run_is_greater_than_4_edi:
		sub eax, (14-4)
		jg .run_is_greater_than_14_edi
		sub edi, 3
		jg .amp_is_greater_than_3_run_is_greater_than_4_edi
		imul eax, (3*8)
		mov eax, DWORD [eax+(3*8*9)+edi*8+(2*8)+vlc_table4+4]
		ret
	.run_is_greater_than_14_edi:
		movzx eax, WORD [eax*4+(14-1)*4+vlc_table1+2]
		movzx edx, WORD [edi*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_17_edi:
		movzx eax, WORD [eax*4+(4-1)*4+(-1+1)*4+vlc_table1+2]
		movzx edx, WORD [edi*4+(17)*4+vlc_table2+2]
		add eax, edx
		ret
	.amp_is_greater_than_3_run_is_greater_than_4_edi:
		movzx eax, WORD [eax*4+9*4+(4-1+1)*4+vlc_table1+2]
		movzx edx, WORD [edi*4+(3)*4+vlc_table2+2]
		add eax, edx
		ret
